from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, Int

Hhalign_V0_1_0 = CommandToolBuilder(tool="hhalign", base_command=["hhalign"], inputs=[ToolInput(tag="in_inputquery_single_sequence", input_type=File(optional=True), prefix="-i", doc=InputDocumentation(doc="input/query: single sequence or multiple sequence alignment (MSA)\nin a3m, a2m, or FASTA format, or HMM in hhm format")), ToolInput(tag="in_inputtemplate_single_sequence", input_type=File(optional=True), prefix="-t", doc=InputDocumentation(doc="input/template: single sequence or multiple sequence alignment (MSA)\nin a3m, a2m, or FASTA format, or HMM in hhm format")), ToolInput(tag="in_no_tags", input_type=Boolean(optional=True), prefix="-notags", doc=InputDocumentation(doc="do NOT / do neutralize His-, C-myc-, FLAG-tags, and trypsin\nrecognition sequence to background distribution (def=-notags)")), ToolInput(tag="in_write_results_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="write results in standard format to file (default=<infile.hhr>)")), ToolInput(tag="in_o_a_three_m", input_type=File(optional=True), prefix="-oa3m", doc=InputDocumentation(doc="write query alignment in a3m or PSI-BLAST format (-opsi) to file (default=none)")), ToolInput(tag="in_aa_three_m", input_type=File(optional=True), prefix="-aa3m", doc=InputDocumentation(doc="append query alignment in a3m (-aa3m) or PSI-BLAST format (-apsi )to file (default=none)")), ToolInput(tag="in_of_as", input_type=File(optional=True), prefix="-Ofas", doc=InputDocumentation(doc="write pairwise alignments in FASTA xor A2M (-Oa2m) xor A3M (-Oa3m) format")), ToolInput(tag="in_add_cons", input_type=Boolean(optional=True), prefix="-add_cons", doc=InputDocumentation(doc="generate consensus sequence as master sequence of query MSA (default=don't)")), ToolInput(tag="in_hide_cons", input_type=Boolean(optional=True), prefix="-hide_cons", doc=InputDocumentation(doc="don't show consensus sequence in alignments (default=show)")), ToolInput(tag="in_hide_pred", input_type=Boolean(optional=True), prefix="-hide_pred", doc=InputDocumentation(doc="don't show predicted 2ndary structure in alignments (default=show)")), ToolInput(tag="in_hide_dssp", input_type=Boolean(optional=True), prefix="-hide_dssp", doc=InputDocumentation(doc="don't show DSSP 2ndary structure in alignments (default=show)")), ToolInput(tag="in_show_ss_conf", input_type=Boolean(optional=True), prefix="-show_ssconf", doc=InputDocumentation(doc="show confidences for predicted 2ndary structure in alignments")), ToolInput(tag="in_id", input_type=Boolean(optional=True), prefix="-id", doc=InputDocumentation(doc="[0,100]  maximum pairwise sequence identity (def=90)")), ToolInput(tag="in_diff", input_type=Boolean(optional=True), prefix="-diff", doc=InputDocumentation(doc="[0,inf[  filter MSAs by selecting most diverse set of sequences, keeping\nat least this many seqs in each MSA block of length 50\nZero and non-numerical values turn off the filtering. (def=100)")), ToolInput(tag="in_cov", input_type=Boolean(optional=True), prefix="-cov", doc=InputDocumentation(doc="[0,100]  minimum coverage with master sequence (%) (def=0)")), ToolInput(tag="in_qid", input_type=Boolean(optional=True), prefix="-qid", doc=InputDocumentation(doc="[0,100]  minimum sequence identity with master sequence (%) (def=0)")), ToolInput(tag="in_qsc", input_type=Boolean(optional=True), prefix="-qsc", doc=InputDocumentation(doc="[0,100]  minimum score per column with master sequence (default=-20.0)")), ToolInput(tag="in_mark", input_type=Boolean(optional=True), prefix="-mark", doc=InputDocumentation(doc="do not filter out sequences marked by '>@'in their name line")), ToolInput(tag="in_no_realign", input_type=Boolean(optional=True), prefix="-norealign", doc=InputDocumentation(doc="do NOT realign displayed hits with MAC algorithm (def=realign)")), ToolInput(tag="in_mact", input_type=Boolean(optional=True), prefix="-mact", doc=InputDocumentation(doc="[0,1[    posterior prob threshold for MAC realignment controlling greedi-\nness at alignment ends: 0:global >0.1:local (default=0.35)")), ToolInput(tag="in_glob", input_type=Boolean(optional=True), prefix="-glob", doc=InputDocumentation(doc="use global/local alignment mode for searching/ranking (def=local)")), ToolInput(tag="in_verbose_mode_screen", input_type=Int(optional=True), prefix="-v", doc=InputDocumentation(doc="verbose mode: 0:no screen output  1:only warings  2: verbose (def=2)"))], outputs=[], container="quay.io/biocontainers/hhsuite:3.3.0--py38pl526h6ed170a_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Hhalign_V0_1_0().translate("wdl")

